;;/*
;;** $Id: lauxlib.h,v 1.88.1.1 2007/12/27 13:02:25 roberto Exp $
;;** Auxiliary functions for building Lua libraries
;;** See Copyright Notice in lua.h
;;*/


%ifndef lauxlib_h
%define lauxlib_h


%include "lua.inc"


%ifdef LUA_COMPAT_GETN
LUALIB_API _luaL_getn
LUALIB_API _luaL_setn
%else
;;#define luaL_getn(L,i)          ((int)lua_objlen(L, i))
;;#define luaL_setn(L,i,j)        ((void)0)  /* no op! */
%endif

%ifdef LUA_COMPAT_OPENLIB
%define luaI_openlib	luaL_openlib
%endif


;;/* extra error code for `luaL_load' */
%define LUA_ERRFILE     (LUA_ERRERR+1)


;;typedef struct luaL_Reg {
;;  const char *name;
;;  lua_CFunction func;
;;} luaL_Reg;

struc luaL_Reg
   .name resd 1 ;;; char ptr
   .func resd 1 ;;; function ptr 
endstruc


;;/*
;;** ===============================================================
;;** some useful macros
;;** ===============================================================
;;*/

;;#define luaL_argcheck(L, cond,numarg,extramsg)	\
;;		((void)((cond) || luaL_argerror(L, (numarg), (extramsg))))
;;#define luaL_checkstring(L,n)	(luaL_checklstring(L, (n), NULL))
;;#define luaL_optstring(L,n,d)	(luaL_optlstring(L, (n), (d), NULL))
;;#define luaL_checkint(L,n)	((int)luaL_checkinteger(L, (n)))
;;#define luaL_optint(L,n,d)	((int)luaL_optinteger(L, (n), (d)))
;;#define luaL_checklong(L,n)	((long)luaL_checkinteger(L, (n)))
;;#define luaL_optlong(L,n,d)	((long)luaL_optinteger(L, (n), (d)))

;;#define luaL_typename(L,i)	lua_typename(L, lua_type(L,(i)))

;;#define luaL_dofile(L, fn) \
;;	(luaL_loadfile(L, fn) || lua_pcall(L, 0, LUA_MULTRET, 0))

;;#define luaL_dostring(L, s) \
	(luaL_loadstring(L, s) || lua_pcall(L, 0, LUA_MULTRET, 0))

;;#define luaL_getmetatable(L,n)	(lua_getfield(L, LUA_REGISTRYINDEX, (n)))

;;#define luaL_opt(L,f,n,d)	(lua_isnoneornil(L,(n)) ? (d) : f(L,(n)))

;;/*
;;** {======================================================
;;** Generic Buffer manipulation
;;** =======================================================
;;*/



;;typedef struct luaL_Buffer {
;;  char *p;			/* current position in buffer */
;;  int lvl;  /* number of strings in the stack (level) */
;;  lua_State *L;
;;  char buffer[LUAL_BUFFERSIZE];
;;} luaL_Buffer;
struc luaL_Buffer
	.p resd 1
	.lvl resd 1
	.L resd 1 ;;lua_State ptr
	.buffer resb LUAL_BUFFERSIZE 
endstruc

;;#define luaL_addchar(B,c) \
;;  ((void)((B)->p < ((B)->buffer+LUAL_BUFFERSIZE) || luaL_prepbuffer(B)), \
;;   (*(B)->p++ = (char)(c)))

;;/* compatibility only */
;;#define luaL_putchar(B,c)	luaL_addchar(B,c)

;;#define luaL_addsize(B,n)	((B)->p += (n))

;;/* }====================================================== */


;;/* compatibility with ref system */

;;/* pre-defined references */
%define LUA_NOREF       (-2)
%define LUA_REFNIL      (-1)

;;#define lua_ref(L,lock) ((lock) ? luaL_ref(L, LUA_REGISTRYINDEX) : \
;;      (lua_pushstring(L, "unlocked references are obsolete"), lua_error(L), 0))

;;#define lua_unref(L,ref)        luaL_unref(L, LUA_REGISTRYINDEX, (ref))

;;#define lua_getref(L,ref)       lua_rawgeti(L, LUA_REGISTRYINDEX, (ref))


%define luaL_reg	luaL_Reg

%endif


